#include "mainwindow.h"
#include "ui_mainwindow.h"
#include <cmath>
#include "ibex.h"
#include "sivia.h"
#include "drawv.h"
#include "simu.h"
#include "drawf.h"
#include "qdebug.h"
using namespace std;


MainWindow::MainWindow(QWidget *parent) :  QMainWindow(parent), ui(new Ui::MainWindow)
{
    ui->setupUi(this);
    ui->graphicsView->setInteractive(true);
    //xmin = -10;    xmax = 10;    ymin = -10;    ymax = 10;
    xmin = -5;    xmax = 5;    ymin = -5;    ymax = 5;
    frame = new Frame(this,ui->graphicsView,xmin,xmax,ymin,ymax);
    on_pushButtonSave_clicked();
}


MainWindow::~MainWindow() {delete ui;}


void MainWindow::on_DrawV_clicked()
{   Function v("V.txt");
    Drawv(v,*frame,0.1);
}



void MainWindow::on_DrawF_clicked()
{
    Drawf(*frame,xmin,xmax,ymin,ymax);
}

void MainWindow::on_pushButtonSolve_clicked()
{   DrawSolve(*frame, 0.1);
}


void MainWindow::on_pushButtonSave_clicked()
{
        QString s1 = ui->plainTextEditV->toPlainText();
        QFile file1("V.txt");
        if (!file1.open(QIODevice::WriteOnly | QIODevice::Text))   return;
        QTextStream out1(&file1);
        out1 << s1 << "\n";
        file1.close();

        QString s2 = ui->plainTextEditf_inf->toPlainText();
        QFile file2("f_inf.txt");
        if (!file2.open(QIODevice::WriteOnly | QIODevice::Text))  return;
        QTextStream out2(&file2);
        out2 << s2 << "\n";
        file2.close();

        QString s3 = ui->plainTextEditf_sup->toPlainText();
        QFile file3("f_sup.txt");
        if (!file3.open(QIODevice::WriteOnly | QIODevice::Text)) return;
        QTextStream out3(&file3);
        out3 << s3 << "\n";
        file3.close();

        QString s4 = ui->plainTextEditgradV->toPlainText();
        QFile file4("gradV.txt");
        if (!file4.open(QIODevice::WriteOnly | QIODevice::Text)) return;
        QTextStream out4(&file4);
        out4 << s4 << "\n";
        file4.close();
}

void MainWindow::on_pushButtonSimu_clicked()
{
    double xM=1.0*rand()/RAND_MAX*(xmax-xmin) + xmin;
    double yM=1.0*rand()/RAND_MAX*(ymax-ymin) + ymin;
    Simu("f_inf.txt","f_sup.txt",*frame,xM,yM);

}
